<?php

namespace Config;

// Create a new instance of our RouteCollection class.
$routes = Services::routes();

// Load the system's routing file first, so that the app and ENVIRONMENT
// can override as needed.
if (file_exists(SYSTEMPATH . 'Config/Routes.php')) {
    require SYSTEMPATH . 'Config/Routes.php';
}

/*
 * --------------------------------------------------------------------
 * Router Setup
 * --------------------------------------------------------------------
 */
$routes->setDefaultNamespace('App\Controllers');
$routes->setDefaultController('Home');
$routes->setDefaultMethod('index');
$routes->setTranslateURIDashes(false);
$routes->set404Override();
$routes->setAutoRoute(true);

/*
 * --------------------------------------------------------------------
 * Route Definitions
 * --------------------------------------------------------------------
 */

// We get a performance increase by specifying the default
// route since we don't have to scan directories.

$routes->get('/', 'Signincontroller::index');
/*go isp 17-08-2023*/
$routes->get('/poplist', 'Signincontroller::MainPopList');
$routes->get('/addpop', 'Signincontroller::AddPop');
$routes->get('/addendpop', 'Signincontroller::AddEndPop');
$routes->post('/AddPop_submit', 'Signincontroller::AddPop_submit');
$routes->get('/editendpop/(:num)', 'Signincontroller::EditEndPop/$1');
$routes->post('/editPopsubmit', 'Signincontroller::EditPop_submit');
$routes->post('popdelete/(:num)', 'Signincontroller::popdelete/$1');
$routes->get('/billingchannel', 'Signincontroller::billingchannel');

$routes->get('/addexpense', 'Signincontroller::AddExpense');
$routes->post('/AddExpns_submit', 'Signincontroller::AddExpns_submit');
$routes->get('/expenselist', 'Signincontroller::ExpenseList');
$routes->get('EditExpense/(:num)', 'Signincontroller::EditExpense/$1');
$routes->post('/update_Expns', 'Signincontroller::update_Expns');
$routes->get('/addincome', 'Signincontroller::AddIncome');
$routes->get('/IncomeList', 'Signincontroller::IncomeList');
$routes->get('/add_Income_Ajax', 'Signincontroller::add_Income_Ajax');
$routes->post('/AddIncome_submit', 'Signincontroller::AddIncome_submit');
$routes->get('Editincome/(:num)', 'Signincontroller::Editincome/$1');
$routes->post('/update_Income', 'Signincontroller::update_Income');

$routes->get('/OthersExp', 'Signincontroller::OthersExpense');
$routes->get('/addOthersExp', 'Signincontroller::add_OthersExpense');
$routes->post('/save_OthersExpense', 'Signincontroller::save_OthersExpense');

$routes->get('/filter_MainPop_commission_reports', 'Signincontroller::filter_MainPop_commission_reports');
$routes->post('/report_MainPop_commission', 'Signincontroller::report_MainPop_commission');
$routes->get('/filter_EndPop_commission', 'Signincontroller::filter_EndPop_commission');
$routes->post('/report_EndPop_commission', 'Signincontroller::report_EndPop_commission');
$routes->get('/filter_Pop_wise_payment_received', 'Signincontroller::filter_Pop_wise_payment_received');
$routes->post('/report_Pop_wise_payment_received', 'Signincontroller::report_Pop_wise_payment_received');
$routes->get('/filter_MainPop_wise_commission', 'Signincontroller::filter_MainPop_wise_commission');
$routes->post('/report_MainPop_wise_commission', 'Signincontroller::report_MainPop_wise_commission');
$routes->get('/filter_MainPop_wise_pl_statment', 'Signincontroller::filter_MainPop_wise_pl_statment');
$routes->post('/report_MainPop_wise_pl_statment', 'Signincontroller::report_MainPop_wise_pl_statment');
$routes->get('/filter_BW_Providers', 'Signincontroller::filter_BW_Providers');
$routes->post('/report_BW_Providers', 'Signincontroller::report_BW_Providers');
$routes->get('/filter_Vendor_wise_BW_reports', 'Signincontroller::filter_Vendor_wise_BW_reports');
$routes->post('/report_Vendor_wise_BW', 'Signincontroller::report_Vendor_wise_BW');
$routes->get('/CostofMainpop', 'Signincontroller::CostofMainpop');
$routes->get('/filter_summary_reports', 'Signincontroller::filter_summary_reports');
$routes->post('/report_summary', 'Signincontroller::report_summary');

$routes->get('/addmore_ajax_depo', 'Signincontroller::AddMore_Ajax_depo');
$routes->get('/Ajax_vendor_typ', 'Signincontroller::Ajax_vendor_typ');
$routes->post('/transaction_submit', 'Signincontroller::Transaction_Submit');
$routes->get('work_edit/(:num)', 'Signincontroller::WorkEdit/$1');
$routes->post('/transaction_update', 'Signincontroller::Transaction_edit_Submit');
$routes->get('/banks', 'Signincontroller::bank_list');
$routes->get('/addbank', 'Signincontroller::addbank');
$routes->post('/banksave', 'Signincontroller::BankSave');
$routes->post('transdelete/(:num)', 'Signincontroller::transdelete/$1');
$routes->post('RemoveTrans_income/(:num)', 'Signincontroller::RemoveTrans_income/$1');


$routes->get('/buy', 'Signincontroller::buyFromVendorlist');
$routes->get('/buyFromVendor', 'Signincontroller::buyFromVendor');

$routes->get('/sell', 'Signincontroller::sellToAgentlist');
$routes->get('/sellToagent', 'Signincontroller::sellToAgent');
$routes->get('/ClientPayment', 'Signincontroller::ClientPayment');
$routes->get('/clientsPaymentlist', 'Signincontroller::clientsPaymentlist');
$routes->get('/vendorsPaymentlist', 'Signincontroller::vendorsPaymentlist');
$routes->get('/VendorPayment', 'Signincontroller::VendorPayment');

$routes->get('BuySellEdit/(:num)', 'Signincontroller::BuySellEdit/$1');
$routes->get('paymentEdit/(:num)', 'Signincontroller::paymentEdit/$1');
$routes->post('/buysell_edit_Submit', 'Signincontroller::buysell_edit_Submit');

$routes->post('/buyFromVendorsubmit', 'Signincontroller::buyFromVendor_Submit');

$routes->get('/customerLedgerFilter', 'Signincontroller::customerLedgerFilter');
$routes->post('/customerLedger', 'Signincontroller::customerLedger');
$routes->get('/vendorLedgerFilter', 'Signincontroller::vendorLedgerFilter');
$routes->post('/vendorLedger', 'Signincontroller::vendorLedger');
$routes->get('/Add_CostofMainpop', 'Signincontroller::Add_CostofMainpop');
$routes->post('/Add_CostofMainpopSubmit', 'Signincontroller::Add_CostofMainpopSubmit');

/*ledger book */


$routes->get('/contact_us', 'Signincontroller::contact_us');
$routes->get('/about_us', 'Signincontroller::about_us');
$routes->get('/pricing', 'Signincontroller::pricing');
$routes->get('/bikeTag', 'Signincontroller::bikeTag');
$routes->get('/carTag', 'Signincontroller::carTag');
$routes->get('/petTag', 'Signincontroller::petTag');
$routes->get('/childTag', 'Signincontroller::childTag');
$routes->get('/privacypolicy', 'Signincontroller::privacypolicy');
$routes->get('/termsandconditions', 'Signincontroller::termsandconditions');
$routes->get('/refundpolicy', 'Signincontroller::refundpolicy');
$routes->get('/distributors', 'Signincontroller::distributors');
$routes->get('/reseller', 'Signincontroller::reseller');
$routes->post('signin', 'Signincontroller::signin');
$routes->get('/scanning', 'Signincontroller::scanning');
$routes->get('/call_create', 'Signincontroller::call_create');
$routes->get('/customer_login', 'Signincontroller::customer_login');


$routes->get('/customer_login_check', 'Signincontroller::customer_login_check');
$routes->get('/customer_logout', 'Signincontroller::customer_logout');
$routes->get('/customer_profile',     'Signincontroller::customer_profile');
$routes->get('/customer_panel',     'Signincontroller::customer_panel');
$routes->get('/customer_tag_list',     'Signincontroller::customer_tag_list');
$routes->get('/career',     'Signincontroller::career');
$routes->get('/custom_emails_option',     'Signincontroller::custom_emails_option');
$routes->post('/custom_emails_option_sent',     'Signincontroller::custom_emails_option_sent');
//$route['tag_options_control/(:any)'] = 'Signincontroller/tag_options_control/$1';
$routes->get('/tag_options_control/(:any)', 'Signincontroller::tag_options_control');
$routes->get('/tag_generate', 'Signincontroller::tag_generate');
$routes->get('/add_tag', 'Signincontroller::tag_add');
$routes->get('/view_tag', 'Signincontroller::view_tag');
$routes->get('/bulk_pdf', 'Signincontroller::bulk_pdf');
$routes->get('/selecttag', 'Signincontroller::tag_type_select');
$routes->get('/buynow', 'Signincontroller::buynowTagForm');
$routes->post('/byenowsubmit', 'Signincontroller::buynowTagFormsubmit');
$routes->post('/tag_options_control_update', 'Signincontroller::tag_options_control_update');
$routes->post('/byenowpaysubmit', 'Signincontroller::buynowTagPaymentSubmit');
$routes->get('/customer_leads', 'Signincontroller::customer_leads');
$routes->post('/customer_leads_filter', 'Signincontroller::customer_leads_filter');

$routes->post('/custom_leads_sms_sent', 'Signincontroller::custom_leads_sms_sent');
$routes->post('/custom_leads_email_sent', 'Signincontroller::custom_leads_email_sent');
//$routes->post('custom_leads_sms_sent', 'Signincontroller::custom_leads_sms_sent');
$routes->post('/report_filter_submit', 'Signincontroller::report_filter_submit');
$routes->get('/order_history', 'Signincontroller::order_history');
$routes->post('/order_history_filter', 'Signincontroller::order_history_filter');
$routes->get('/report_filter', 'Signincontroller::report_filter');
$routes->post('/customer_report_excel', 'Signincontroller::customer_report_excel');
$routes->post('/order_history_update', 'Signincontroller::order_history_update');
$routes->post('/tag_registration_submit', 'Signincontroller::tag_registration_submit');
$routes->post('/contactus_mail', 'Signincontroller::contactus_mail');
$routes->get('/customer_invoice/(:num)', 'Signincontroller::customer_invoice');
$routes->post('/tag_add_submit', 'Signincontroller::tag_add_submit');
$routes->post('/customer_profile_photo_update', 'Signincontroller::customer_profile_photo_update');
$routes->post('/customer_profile_info_update', 'Signincontroller::customer_profile_info_update');
$routes->get('/date_range_bulk_pdf_filter', 'Signincontroller::date_range_bulk_pdf_filter');
$routes->post('/date_range_bulk_pdf_submit', 'Signincontroller::date_range_bulk_pdf_submit');
$routes->post('/customer_edit_submit', 'Admin::customer_edit_submit');
$routes->post('/tag_edit_submit', 'Admin::tag_edit_submit');
$routes->post('/tag_search_submit', 'Admin::tag_search_submit');
$routes->post('/order_history_search', 'Signincontroller::order_history_search');
$routes->post('/leads_history_search', 'Signincontroller::leads_history_search');
$routes->get('tagpricing', 'Signincontroller::tagpricing');
$routes->post('/tagpricing_update', 'Signincontroller::tagpricing_update');
$routes->post('/customer_search_submit', 'Admin::customer_search_submit');
$routes->get('/customerlist', 'Admin::customerlist');
$routes->get('/success_registration', 'Signincontroller::success_registration');
$routes->get('/failed_registration', 'Signincontroller::failed_registration');

/*for EDC by ft@july_2024*/
$routes->get('/edc_users', 'EDCcontroller::edc_users');
$routes->post('/edc_users', 'EDCcontroller::edc_users');
$routes->post('/import', 'EDCcontroller::import');
$routes->get('/districs', 'EDCcontroller::districs');
$routes->get('/upozillas', 'EDCcontroller::upozillas');
$routes->get('/unions', 'EDCcontroller::unions');
$routes->get('/steck_holders', 'EDCcontroller::steck_holders');
$routes->get('edit_end_user/(:num)', 'EDCcontroller::Edit_end_user/$1');
$routes->post('UpdateEndUser_submit', 'EDCcontroller::UpdateEndUser_submit');
$routes->post('get_upozillas_by_district', 'EDCcontroller::get_upozillas_by_district');
$routes->post('get_unions_by_upozilla', 'EDCcontroller::get_unions_by_upozilla');
$routes->get('/topsheet', 'EDCcontroller::topsheet');
$routes->post('/topsheet', 'EDCcontroller::topsheet');
$routes->post('/update_status_topsheet', 'EDCcontroller::update_status_topsheet');
$routes->get('/topsheet_filter', 'EDCcontroller::topsheet_filter');
$routes->get('/top_sheet_list', 'EDCcontroller::top_sheet_list');
$routes->get('/topsheet_update_edc_users', 'EDCcontroller::topsheet_update_edc_users');
$routes->post('/topsheet_update_edc_users', 'EDCcontroller::topsheet_update_edc_users');
$routes->get('topsheet_update_Edit_end_user/(:num)', 'EDCcontroller::topsheet_update_Edit_end_user/$1');
$routes->post('topsheet_UpdateEndUser_submit', 'EDCcontroller::topsheet_UpdateEndUser_submit');

$routes->get('EDC_Work_Report_Summery', 'EDCcontroller::EDC_Work_Report_Summery');
$routes->get('print_list', 'EDCcontroller::print_list');
$routes->post('print_list', 'EDCcontroller::print_list');

$routes->get('/generate_topsheet_excel/(:num)', 'EDCcontroller::generate_topsheet_excel/$1');
$routes->get('/generate_topsheet_pdf/(:num)', 'EDCcontroller::generate_topsheet_pdf/$1');

$routes->get('/edit_generated_topsheet/(:num)', 'EDCcontroller::edit_generated_topsheet/$1');
$routes->post('/update_generated_topsheet/(:num)', 'EDCcontroller::update_generated_topsheet/$1');
$routes->get('edc_agent_list', 'EDCcontroller::edc_agent_list');
$routes->get('Edc_add_agent', 'EDCcontroller::Edc_add_agent');
$routes->get('Edc_add_sub_agent', 'EDCcontroller::Edc_add_sub_agent');
$routes->post('Edc_add_agent_submit', 'EDCcontroller::Edc_add_agent_submit');
$routes->get('/EditEdcagent/(:num)', 'EDCcontroller::EditEdcagent/$1');
$routes->post('/EditAgent_submit', 'EDCcontroller::EditAgent_submit');
$routes->post('Edc_agentdelete/(:num)', 'EDCcontroller::Edc_agentdelete/$1');
/*END -for EDC by ft@2024*/

$routes->post('mobile_login', 'Mobile_api::mobile_login');
$routes->get('getAllcustomer', 'Mobile_api::index');
//$routes->get('api_get_all_customer', 'Mobile_api::all_customer');
$routes->get('single_customer_info', 'Mobile_api::single_customer_info');
$routes->post('customer_info_update', 'Mobile_api::customer_info_update');
$routes->post('customer_image_update', 'Mobile_api::customer_image_update');
$routes->post('customer_lead_insert', 'Mobile_api::customer_lead_insert');
$routes->get('customer_tag_registration', 'Mobile_api::customer_tag_registration');
$routes->post('customer_tag_list_api', 'Mobile_api::customer_tag_list_api');
$routes->get('tag_options_api', 'Mobile_api::tag_options_api');
$routes->post('tag_options_api_update', 'Mobile_api::tag_options_api_update');
$routes->post('tag_response', 'Mobile_api::tag_response');
$routes->post('tag_registration_carandbike', 'Mobile_api::tag_registration_carandbike');
$routes->post('tag_registration_pet', 'Mobile_api::tag_registration_pet');
$routes->post('tag_registration_school', 'Mobile_api::tag_registration_school');
$routes->get('pricing_plan', 'Mobile_api::pricing_plan');


/*
 * --------------------------------------------------------------------
 * Additional Routing
 * --------------------------------------------------------------------
 *
 * There will often be times that you need additional routing and you
 * need it to be able to override any defaults in this file. Environment
 * based routes is one such time. require() additional route files here
 * to make that happen.
 *
 * You will have access to the $routes object within that file without
 * needing to reload it.
 */
if (file_exists(APPPATH . 'Config/' . ENVIRONMENT . '/Routes.php')) {
    require APPPATH . 'Config/' . ENVIRONMENT . '/Routes.php';
}
