<?php
namespace App\Controllers;

use CodeIgniter\RESTful\ResourceController;
use CodeIgniter\HTTP\RequestInterface;
use App\Models\SigninModel;
use App\Libraries\JwtLibrary;


class Mobile_api extends ResourceController
{
    protected $format    = 'json';
	
	private $jwtLib;
	
	public function __construct() {
		$this->jwtLib = new JwtLibrary();
	}
    // api authentication /faysaltanim-2023/
    
    public function mobile_login() {
		
		$username = $this->request->getVar('mobile');
		$password = $this->request->getVar('key');
		$model = new SigninModel();
        $data = $model->table('customers')->where(array('mobile' => $username, 'customer_key' => $password))->first();
        if($data) {
            $id=$data['id'];
			$headers = array('alg'=>'HS256','typ'=>'JWT');
			$payload = array('id'=>$id,'username'=>$username, 'exp'=>(time() + 31536000));
				
            	//return $this->respond($payload);die();
			$jwt = $this->jwtLib->generate_jwt($headers, $payload);
		
            return $this->respond(array('token' => $jwt));
        } else {
            return $this->failNotFound('No user found');
        }
    }
    
    
    public function index(){
        $bearer_token = $this->jwtLib->get_bearer_token();
        $model = new SigninModel();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
        //var_dump($is_jwt_valid);die();
		if($is_jwt_valid) {
		    //echo 'hi'; die();
			return $this->respond($model->findAllcustomer());
		} else {
		     //echo 'hey'; die();
			return $this->failUnauthorized('Unauthorized Access');
		}
        
    }
    
     // all users
    public function all_customer(){
     $model = new SigninModel();
      $data['customers'] = $model->findAllcustomer();
      return $this->respond($data);
    }
    // create
    public function create() {
        $bearer_token = $this->jwtLib->get_bearer_token();
        $model = new SigninModel();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
		    $data = [
                    'customer_name'     =>$_POST['owner_name'],
                        'mobile'            =>$_POST['phone_number'],
                        'email'             =>$_POST['email'],
                        'state'             =>$_POST['state'],
                        'city'              =>$_POST['city'],
                        'vechicle_type'     =>$tag_details->vehicle_typ,
                        'qr_id'             =>$_POST['code'],
                        'active_date'       =>$date,
                        'status'            =>1,
                ];
                $model->insert($data);
                $response = [
                  'status'   => 201,
                  'error'    => null,
                  'messages' => [
                      'success' => 'Customer created successfully'
                  ]
              ];
             
			return $this->respond($response);
		} else {
			return $this->failUnauthorized('Unauthorized Access');
		}
        
    }
    // single user
    public function single_customer_info($id = null){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
		    $data = [
                'id' => $this->request->getVar('id'),
               
            ];
            $id=$data['id'];
            $model = new SigninModel();
            $data = $model->ative_customer_info_by_id($id);
            if($data){
                return $this->respond($data);
            }else{
                return $this->failNotFound('No data found');
            }
		} else {
		     //echo 'hey'; die();
			return $this->failUnauthorized('Unauthorized Access');
		}
        
                 
            
        
    }
    // update
    public function customer_info_update(){
            $bearer_token = $this->jwtLib->get_bearer_token();
    		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
    		if($is_jwt_valid) {
    		    $model = new SigninModel();
                $mob = $this->request->getVar('mobile');
                $data = [
                    'customer_name'     =>$this->request->getVar('name'),
                    'email'             =>$this->request->getVar('email'),
                    'state'             =>$this->request->getVar('state'),
                    'city'              =>$this->request->getVar('city'),
                    'photo_link'        =>$this->request->getVar('photo_link'),
                ];
                $save=$model->updateUserinfo($data,$mob);
                if($save){
                $response = [
                    'status'   => 200,
                    'error'    => null,
                    'messages' => [
                        'success' => 'Information update successfully'
                    ]
                ];
                }else{
                     $response = [
                    'status'   => 400,
                    'error'    => true,
                    'messages' => [
                        'failed' => 'Information update unsuccessfull'
                    ]
                ];
            }
			return $this->respond($response);
    		} else {
            return $this->failUnauthorized('Unauthorized Access');
    		}
             
        
    }
    public function customer_image_update(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		//var_dump($this->request->getVar('id'));die();
		if($is_jwt_valid) {
		    $model = new SigninModel();
                    $id =$this->request->getVar('id');
                        $validationRule = [
                            'userfile' => [
                                'label' => 'Image File',
                                'rules' => [
                                    'uploaded[userfile]',
                                    'is_image[userfile]',
                                    'mime_in[userfile,image/jpg,image/jpeg,image/gif,image/png,image/webp]',
                                    'max_size[userfile,900]',
                                    'max_dims[userfile,1024,768]',
                                ],
                            ],
                        ];
                        if (! $this->validate($validationRule)) {
                            $response= ['error' => $this->validator->getErrors(),
                                        'status'   => 400,];
                
                        }
                        $img = $this->request->getVar('userfile');//$this->request->getFile('userfile');
                        
                        if (! $img->hasMoved()) {
                            $newName = $img->getRandomName();
                            $img->move(ROOTPATH . 'public/uploads/', $newName);
                            $filepath =  'uploads/' . $newName;
                            $data = ['uploaded_fileinfo' => new File($filepath)];
                            $imagelocation=array(
                                'customer_photo'=>$filepath,
                                );
                            $model->updateUserProfilePic($imagelocation,$id);
                            //var_dump($filepath2);
                            $response = [
                              'status'   => 200,
                              'error'    => null,
                              'messages' => [
                                  'success' => 'Profile photo updated successfully'
                              ]
                            ];
                        }
                        
                        $response = ['error' => 'The file has already been moved.',
                        'status'   => 400,];
                
                        return $this->respond($response);
		} else {
		     //echo 'hey'; die();
			return $this->failUnauthorized('Unauthorized Access');
		}
                 
            
        
    }
    public function customer_lead_insert(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
		    $date = date("d-m-Y");
              $model=new SigninModel();
                
                $products = $this->request->getVar('category');
                
                 $quantities = $this->request->getVar('quantity');
            		$i=0;
            		foreach($products as $key => $value){
                         $data = array(
                    		'customer_name'     => $this->request->getVar('name'),
                            'mobile'    => $this->request->getVar('mobile'),
                            'email' => $this->request->getVar('email'),
                            'product_category' => $products[$i],
                            'product_quantity' => $quantities[$i],
                            'delivary_address'  =>$this->request->getVar('deliveryaddress'),
                            'landmark'  => $this->request->getVar('lndmrk'),
                            'zip_code'  => $this->request->getVar('zipcode'),
                            'state'  => $this->request->getVar('state'),
                            'city'  => $this->request->getVar('city'),
                            'payment_method'  => $this->request->getVar('pay_method'),
                            'payment_details'  =>$this->request->getVar('pay_id'),
                            'payment_status'  =>$this->request->getVar('pay_status'),
                            'payment_amount'  =>$this->request->getVar('pay_amount'),
                            'create_date'  =>$this->request->getVar('create_date'),
                            'status'  =>$this->request->getVar('status'),
                    		);
                    		$i++;
            	
                		   $model->savebuynow($data);
                		}
                 
               $response = [
              'status'   => 200,
              'error'    => null,
              'messages' => [
                  'success' => 'Information saved'
              ]
          ];
          return $this->respond($response);
		} else {
		     //echo 'hey'; die();
			return $this->failUnauthorized('Unauthorized Access');
		}
        
        
    }
    public function customer_tag_registration(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
		    $model=new SigninModel();
            $code=$this->request->getVar('code');
            $tag_details=$model->find_tag_details($code);
            $date = date("d-m-Y");
                $data=array(
                    'customer_name'     =>$this->request->getVar('owner_name'),
                    'mobile'            =>$this->request->getVar('phone_number'),
                    'email'             =>$this->request->getVar('email'),
                    'state'             =>$this->request->getVar('state'),
                    'city'              =>$this->request->getVar('city'),
                    'vechicle_type'     =>$tag_details->vehicle_typ,
                    'qr_id'             =>$this->request->getVar('code'),
                    'active_date'       =>$date,
                    'status'            =>1,
                    'purchase_source'   =>'online',
                    'vehicle_no'        =>$this->request->getVar('vehicle_no'),
                    'notification_status'   =>'1',
                    'call_status'       =>1,
                    'sms_status'        =>1,
                    'pause_tag'         =>0,
                    'emergency_num'     =>'',
                    'customer_photo'    =>'n/a',
                );
                 
                $model->tag_reg_save($data);
                $tagdata=array(
                    'scans'     =>1,
                   
                );
                $model->tagurlupdate($tagdata,$code);
                 $response = [
                      'status'   => 200,
                      'error'    => null,
                      'messages' => [
                          'success' => 'Registrtion successfully done'
                      ]
                  ];
		} else {
			return $this->failUnauthorized('Unauthorized Access');
		}
        
            
    }
    public function tag_response(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		//if($is_jwt_valid) {
            $model=new SigninModel();
            $tagid=$this->request->getVar('tag_id');
            //var_dump($tagid);die();
            $data['tags_res']=$model->tagResponse($tagid);
            return $this->respond($data['tags_res']);
            
        // }
       //else{
            //return $this->failUnauthorized('Unauthorized Access');
       // }
         
    }
    //customer all tag
     public function customer_tag_list_api(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
            $model=new SigninModel();
            $customer_mobile=$this->request->getVar('mobile');
            
            $data['alltags']=$model->getalltagdetails($customer_mobile);
            return $this->respond($data['alltags']);
            
         }
       else{
            return $this->failUnauthorized('Unauthorized Access');
        }
         
    }
    //tag feature
    public function tag_options_api(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
		    
                $tag_id=$this->request->getVar('tag_id');
                //echo $tag_id;die();
                $model = new SigninModel();
                $data['tag_info']=$model->tag_info_by_id($tag_id);
                $id=$data['tag_info']->id;
			return $this->respond($model->tag_feature_by_id($id));
		} else {
		     //echo 'hey'; die();
			return $this->failUnauthorized('Unauthorized Access');
		}
        
    }
    public function tag_options_api_update(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
                $id=$this->request->getVar('qr_id');
                //echo $id;die();
                $insert_data=array(
                 'notification_status'=>$this->request->getVar('notifications'),
                 'call_status'=>$this->request->getVar('dis_calls'),
                 'pause_tag'=>$this->request->getVar('pause_tag'),
                 'emergency_num'=>$this->request->getVar('emgncy_num_input'),
                 );
                
                $model = new SigninModel();
                $save=$model->tag_options_update($insert_data,$id);
                if($save){
                $response = [
                    'status'   => 200,
                    'error'    => null,
                    'messages' => [
                        'success' => 'Features updated successfully'
                    ]
                ];
                }else{
                     $response = [
                    'status'   => 400,
                    'error'    => true,
                    'messages' => [
                        'failed' => 'Features updated unsuccessfull'
                    ]
                ];
                }
                
			return $this->respond($response);
		} else {
		     //echo 'hey'; die();
			return $this->failUnauthorized('Unauthorized Access');
		}
        
    }
    public function tag_registration_carandbike(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		//if($is_jwt_valid) {
        $model=new SigninModel();
        $code=$this->request->getVar('code');
        $tag_typ=$this->request->getVar('tag_type');
        $date = date("d-m-Y");
            $data=array(
                'customer_name'     =>$this->request->getVar('owner_name'),
                'mobile'            =>$this->request->getVar('phone_number'),
                'email'             =>$this->request->getVar('email'),
                'state'             =>$this->request->getVar('state'),
                'city'              =>$this->request->getVar('city'),
                'vechicle_type'     =>$tag_typ,
                'qr_id'             =>$this->request->getVar('code'),
                'active_date'       =>$date,
                'status'            =>1,
                'purchase_source'   =>'online',
                'vehicle_no'        =>$this->request->getVar('vehicle_no'),
                'notification_status'   =>'1',
                'call_status'       =>1,
                'sms_status'        =>1,
                'pause_tag'         =>0,
                'emergency_num'     =>'',
                'customer_photo'    =>'n/a',
            );
            $save=$model->tag_reg_save($data);
            $tagdata=array(
                'scans'     =>1,
               
            );
            $model->tagurlupdate($tagdata,$code);
            if($save){
            $response = [
                'status'   => 200,
                'error'    => null,
                'messages' => [
                    'success' => 'Tag registration successfull'
                ]
            ];
            }else{
                 $response = [
                'status'   => 400,
                'error'    => true,
                'messages' => [
                    'failed' => 'Tag registration unsuccessfull'
                ]
            ];
            }
			return $this->respond($response);
	//	}
		//else {
		//	return $this->failUnauthorized('Unauthorized Access');
	//	}
      
    }
    public function tag_registration_pet(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		//if($is_jwt_valid) {
        $model=new SigninModel();
        $code=$this->request->getVar('code');
        $tag_typ=$this->request->getVar('tag_type');
        $date = date("d-m-Y");
            $data=array(
                'customer_name'     =>$this->request->getVar('owner_name'),
                'mobile'            =>$this->request->getVar('phone_number'),
                'email'             =>$this->request->getVar('email'),
                'state'             =>$this->request->getVar('state'),
                'city'              =>$this->request->getVar('city'),
                'vechicle_type'     =>$tag_typ,
                'qr_id'             =>$this->request->getVar('code'),
                'active_date'       =>$date,
                'status'            =>1,
                'purchase_source'   =>'online',
                'pet_name'          =>$this->request->getVar('pet_name'),
                'specie'            =>$this->request->getVar('specie'),
                'breed'             =>$this->request->getVar('breed'),
                'notification_status'   =>'1',
                'call_status'       =>1,
                'sms_status'        =>1,
                'pause_tag'         =>0,
                'emergency_num'     =>'',
                'customer_photo'    =>'n/a',
            );
            $save=$model->tag_reg_save($data);
            $tagdata=array(
                'scans'     =>1,
               
            );
            $model->tagurlupdate($tagdata,$code);
             if($save){
            $response = [
                'status'   => 200,
                'error'    => null,
                'messages' => [
                    'success' => 'Tag registration successfull'
                ]
            ];
            }else{
                 $response = [
                'status'   => 400,
                'error'    => true,
                'messages' => [
                    'failed' => 'Tag registration unsuccessfull'
                ]
            ];
            }
			return $this->respond($response);
		//}
	//	else {
	//		return $this->failUnauthorized('Unauthorized Access');
	//	}
      
    }
    public function tag_registration_school(){
        $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		//if($is_jwt_valid) {
        $model=new SigninModel();
        $code=$this->request->getVar('code');
        $tag_typ=$this->request->getVar('tag_type');
        $date = date("d-m-Y");
            $data=array(
                'customer_name'     =>$this->request->getVar('student_name'),
                'mobile'            =>$this->request->getVar('fatherphone_number'),
                'email'             =>$this->request->getVar('email'),
                'state'             =>$this->request->getVar('state'),
                'city'              =>$this->request->getVar('city'),
                'vechicle_type'     =>$tag_typ,
                'qr_id'             =>$this->request->getVar('code'),
                'active_date'       =>$date,
                'status'            =>1,
                'purchase_source'   =>'online',
                'school_name'       =>$this->request->getVar('school_name'),
                'school_code'       =>$this->request->getVar('school_code'),
                'student_name'      =>$this->request->getVar('student_name'),
                'father_name'       =>$this->request->getVar('father_name'),
                'father_mobile'     =>$this->request->getVar('fatherphone_number'),
                'mother_name'       =>$this->request->getVar('mother_name'),
                'mother_mobile'     =>$this->request->getVar('motherphone_number'),
                'gurdian_name'      =>$this->request->getVar('gurdian_name'),
                'gurdian_mobile'    =>$this->request->getVar('gurdianphone_number'),
                'gurdian_relation'  =>$this->request->getVar('gurdianrealtion'),
                'notification_status'   =>'1',
                'call_status'       =>1,
                'sms_status'        =>1,
                'pause_tag'         =>0,
                'emergency_num'     =>'',
                'customer_photo'    =>'n/a',
            );
            $save=$model->tag_reg_save($data);
            $tagdata=array(
                'scans'     =>1,
               
            );
            $model->tagurlupdate($tagdata,$code);
            if($save){
            $response = [
                'status'   => 200,
                'error'    => null,
                'messages' => [
                    'success' => 'Tag registration successfull'
                ]
            ];
            }else{
                 $response = [
                'status'   => 400,
                'error'    => true,
                'messages' => [
                    'failed' => 'Tag registration unsuccessfull'
                ]
            ];
            }
			return $this->respond($response);
		//}
		//else {
		//	return $this->failUnauthorized('Unauthorized Access');
		//}
    }
    public function pricing_plan(){
      $bearer_token = $this->jwtLib->get_bearer_token();
		$is_jwt_valid = $this->jwtLib->is_jwt_valid($bearer_token);
		if($is_jwt_valid) {
            $model = new SigninModel();
            $data['price'] = $model->tag_price();
            return $this->respond($data);
		}
	else {
			return $this->failUnauthorized('Unauthorized Access');
		}
    }
    // delete
    public function delete($id = null){
        $model = new SigninModel();
        $data = $model->where('id', $id)->delete($id);
        if($data){
            $model->delete($id);
            $response = [
                'status'   => 200,
                'error'    => null,
                'messages' => [
                    'success' => 'Employee successfully deleted'
                ]
            ];
            return $this->respondDeleted($response);
        }else{
            return $this->failNotFound('No employee found');
        }
    }
}