<?php namespace App\Controllers;
use CodeIgniter\Controller;
use App\Models\OrderHistoryModel;

class Orderhistory extends Controller{
	private $base_url,$client_id,$client_secret,$d_b,$country_code,$inputs;

	function __construct(){
	
		/////////////////////////				
		$this->d_b = \Config\Database::connect();
	}

    public function add() {
        
    	date_default_timezone_set("Asia/Kuala_Lumpur");
    	helper(['form', 'url']);

        $model=new OrderHistoryModel();

        $this->inputs = $this->request;

        $success = $model->save([
			"sender_name"=> $this->get_val("sender_name"),
			"sender_contact"=> $this->get_val("sender_contact"),
			"sender_address_one"=> $this->get_val("sender_address_one"),
			"sender_address_two"=> $this->get_val("sender_address_two"),
			"sender_zip"=> $this->get_val("sender_zip"),
			"sender_city"=> $this->get_val("sender_city"),
			"sender_state"=> $this->get_val("sender_state"),
			"receiver_name"=> $this->get_val("receiver_name"),
			"receiver_contact"=> $this->get_val("receiver_contact"),
			"receiver_address_one"=> $this->get_val("receiver_address_one"),
			"receiver_address_two"=> $this->get_val("receiver_address_two"),
			"receiver_zip"=> $this->get_val("receiver_zip"),
			"receiver_city"=> $this->get_val("receiver_city"),
			"receiver_state"=> $this->get_val("receiver_state"),
			"within_peninsular_malaysia"=> $this->get_val("within_peninsular_malaysia"),
			"item_description"=> $this->get_val("item_description"),
			"price"=> $this->get_val("price"),
			"weight"=> $this->get_val("weight"),
			"length"=> $this->get_val("length"),
			"width"=> $this->get_val("width"),
			"height"=> $this->get_val("height")
		]);
		if($success){
			$api_data = [
			   "service_type"=> "Parcel",
			   "service_level"=> "Standard",
			   "requested_tracking_number"=> time(),
			   "reference"=>[
			      "merchant_order_number"=> time()
			   ],
			   "from"=>[
			      "name"=> "{$this->get_val("sender_name")}",
			      "phone_number"=> "{$this->get_val("sender_contact")}",
			      "email"=> "test@email.com",
			      "address"=>[
			         "address1"=> "{$this->get_val("sender_address_one")}",
			         "address2"=> "{$this->get_val("sender_address_two")}",
			         "country"=> $this->country_code,
			         "postcode"=> "{$this->get_val("sender_zip")}"
			      ]
			   ],
			   "to"=>[
			      "name"=> "{$this->get_val("receiver_name")}",
			      "phone_number"=> "{$this->get_val("receiver_contact")}",
			      "email"=> "test@email.com",
			      "address"=>[
			         "address1"=> "{$this->get_val("receiver_address_one")}",
			         "address2"=> "{$this->get_val("receiver_address_two")}",
			         "country"=> $this->country_code,
			         "postcode"=> "{$this->get_val("receiver_zip")}"
			      ]
			   ],
			   "parcel_job"=>[
			      "is_pickup_required"=>false,
			      "delivery_start_date"=> (string) date('Y-m-d'),
			      "delivery_timeslot"=>[
			         "start_time"=> "09:00",
			         "end_time"=> "22:00",
			         "timezone"=> "Asia/Kuala_Lumpur"
			      ],
			      "delivery_instructions"=> "Please be careful with the v-day flowers.",
			      "dimensions"=>[
			         "weight"=>(int)$this->get_val("weight"),
			         "size"=> "{$this->get_val("length")}x{$this->get_val("width")}x{$this->get_val("height")}"
			      ]
			   ]
			];

	    	$this->send_to_ninja_van(json_encode($api_data));

		}
    }

    private function get_val($field){
    	return $this->inputs->getVar($field)??'';
    }

    private function send_to_ninja_van($data){
    	
    }
    
    private function access_token(){
    	$token = $this->fetch_token();  	

    	if($token){
			return $token;
    	}else{
    		$this->generate_access_token();
    		return $this->fetch_token();
    	}
    }

    private function fetch_token(){
		$get_api_credential = $this->d_b->query("select * from options where __name__='api_credential'"); 

	    $api_credential = $get_api_credential->getResult();
	    if(!empty($api_credential)){
	    	if(isset($api_credential[0]) && isset($api_credential[0]->__value__)){
	    		try{
	    			$parseAT = json_decode($api_credential[0]->__value__,true);
					$access_token = $parseAT['access_token']??'';
					$created_at = $parseAT['created_at']??'';
					$expires_in = $parseAT['expires_in']??'';
					if($access_token && ((int)time()-(int)$created_at)<$expires_in){
						return $access_token;
					}

	    		}catch(Exception $e){}	    		
	    	}
			
	    }
	    return '';
	}

	private function generate_access_token(){

		$url = $this->base_url.'/'.$this->country_code.'/2.0/oauth/access_token';
		$data = [
		    'client_id' => $this->client_id,
		    'client_secret' => $this->client_secret,
		    'grant_type'   => 'client_credentials'
		];
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

		$response = curl_exec($ch);
		curl_close($ch);

		$data = json_decode($response,true);

		if(isset($data['access_token'])){
			$data['created_at'] = time();
		}
		$data = json_encode($data);

		$get_api_credential = $this->d_b->query("select * from options where __name__='api_credential'"); 

	    $api_credential = $get_api_credential->getResult();
	    if(empty($api_credential)){
	    	$this->d_b->query("INSERT INTO options (__name__, __value__) VALUES ('api_credential', '$data')");
	    }else{
	    	$this->d_b->query("update options set __value__='$data' where __name__='api_credential' ");
	    }
		
	}
    
}