<?php namespace App\Controllers;

use CodeIgniter\Controller;
use App\Libraries\Hash;

class Auth extends Controller{

	public function __construct(){
		helper(['url','form']);

	}

	public function index()
	{
		dd(1234);
		return view('auth/login');
	}

	public function register(){
		return view('auth/register');
	}

	public function save(){

		$validation = $this ->validate([

			'name' => [
				'rules' => 'required',
				'errors' =>[
					'requird'=> 'Your name is required'
				]
			],

			'email' => [
				'rules' => 'required|valid_email|is_unique[admin.email]', //table name.table column name
				'errors' =>[
					'requird'=> 'Your name is required',
					'valid_email' => 'You must enter a valid email',
					'is_unique' => 'Email already taken'

				]
			],

			'password' => [
				'rules' => 'required|min_length[6]',
				'errors' =>[
					'requird'=> 'Password is required',
					'min_length' => 'Password must have atleast 6 characters'
				]
			]




		]);

		if(!$validation){
			return view('auth/register',['validation'=> $this ->validator]);

		}else{
			//echo "Form validated Sucessfully";

			//insert into database
			$name = $this->request->getPost('name');
			$email = $this->request->getPost('email');
			$password = $this->request->getPost('password');

			$values = [
				'name'=> $name,
				'email'=> $email,
				'password'=> Hash::make($password),

			];

			//print_r($values);

			$adminModel = new \App\Models\AdminModel();
			$query = $adminModel -> insert($values);

			if(!$query){
				return redirect()->back()->with('fail','Register unsucessfully! Something went wrong! ');
			}else{
				// return redirect()->to('auth/register')->with('success','You are now register Sucessfully! ');

				$last_id = $adminModel -> insertID();
				session() -> set('loggedAdmin',$last_id);
				return redirect()-> to ('/Dashboard');
			}


		}
	}

	public function checkLogin(){
		echo'Check login process..........';
		die();
		//validate
		$validation = $this->validate([
			'email' => [
				'rules' => 'required|valid_email|is_not_unique[admin.email]',
				'errors' => [
					'required'=> 'Email is required',
					'valid_email' => 'Enter a valid email address',
					'is_not_unique' => 'This email is not registered on our service'
				]

			],
			'password'=>[
				'rules' => 'required|min_length[6]',
				'errors' => [
					'required'=> 'Password is required',
					'min_length' => 'Password must have atleat 5 characters in length'

				]
			]

		]);

		if(!$validation){
			echo'Check login process..........';
			var_dump($validation);
			return view('auth/login',['validation'=> $this ->validator]);

		}else{

			echo "Login Sucessfully validated";

			$email = $this->request->getPost('email');
			$password = $this->request->getPost('password');

			$adminModel = new \App\Models\AdminModel();
			$admin_info = $adminModel -> where('email',$email)->first();
			$check_password = Hash::check($password,$admin_info['password']);

			if(!$check_password){
				session()->setFlashdata('fail','Incorrect password');
				return redirect()->to('/auth')->withInput();
			}else{
				$admin_id = $admin_info['id'];
				session() -> set('loggedAdmin',$admin_id);
				return redirect() -> to ('Dashboard');
			}			

		}
	}


	public function logout(){
		if(session() -> has('loggedAdmin')){
			session() -> remove('loggedAdmin');
			return redirect() -> to('/auth?acess=out')-> with('fail','You are logged out!');
		}
	}

	public function admin_profile($id){

		$adminModel = new \App\Models\AdminModel();
		$loggedAdminID = session() ->get('loggedAdmin');
		$adminInfo = $adminModel -> find($loggedAdminID);


		$db = \Config\Database::connect();
		$query   = $db->query("SELECT * FROM admin where id = '$id' ");
		


		$data = [
			
			'adminInfo' => $adminInfo,
			'admin' => $query,

		];

		// echo view("layouts/header",$data);
		// echo view('Dashboard/admin_profile',$data);
		// echo view("layouts/footer",$data);

		return view('auth/admin_view_profile',$data);

	}

	public function edit($loggedAdminID){

		$adminModel = new \App\Models\AdminModel();
		$loggedAdminID = session() ->get('loggedAdmin');
		$adminInfo = $adminModel -> find($loggedAdminID);




		$data = [
			'page_heading' => 'Welcome to h',
			'adminInfo' => $adminInfo

		];

		return view('auth/edit_profile',$data);

		
		
		// echo view("layouts/header",$data);
		// echo view('Dashboard/admin_profile',$data);
		// echo view("layouts/footer",$data);

	}

	public function update($loggedAdminID){

		$adminModel = new \App\Models\AdminModel();
		$loggedAdminID = session() ->get('loggedAdmin');
		$adminInfo = $adminModel -> find($loggedAdminID);


		$validation = $this ->validate([

			'name' => [
				'rules' => 'required',
				'errors' =>[
					'requird'=> 'Your name is required'
				]
			],

			'email' => [
				'rules' => 'required|valid_email|is_unique[admin.email]', //table name.table column name
				'errors' =>[
					'requird'=> 'Your name is required',
					'valid_email' => 'You must enter a valid email',
					'is_unique' => 'Email already taken'

				]
			]

		]);

		if(!$validation){
			return view('auth/edit_profile',['validation'=> $this ->validator,'adminInfo' => $adminInfo,]);

		}else{




			$adminModel = new \App\Models\AdminModel();
			$data['admin'] = $adminModel->find($loggedAdminID);

			$data = [
				'name' => $this->request->getPost('name'),
				'email' => $this->request->getPost('email')

			];


			$adminModel->update($loggedAdminID,$data);
			return redirect()->to(site_url('auth/edit/'.$adminInfo['id']))->with('status','Profile Updated Sucessfully!');
		}

	}

	public function change_password($id){

		$adminModel = new \App\Models\AdminModel();
		$loggedAdminID = session() ->get('loggedAdmin');
		$adminInfo = $adminModel -> find($loggedAdminID);
		
		
		$admin = $adminModel ->find($id);
     

		$password = $this->request->getPost('oldpassword');
		

		$admin_id = $adminModel -> where('id',$loggedAdminID)->first();
		$check_password = Hash::check($password,$admin_id['password']);

		//dd($check_password);

		if(!$check_password){
			session()->setFlashdata('error','Incorrect Old password');
			return redirect()->to('auth/edit/'.$adminInfo['id'])->withInput();
		}

			$validation = $this ->validate([
			
				'oldpassword' => [
					'rules' => 'required|min_length[6]',
					'errors' =>[
						'required'=> 'Old password is required',
						'min_length' => 'Password must have at least 6 characters'
					]
				],
				'newpassword' => [
					'rules' => 'required|min_length[6]',
					'errors' =>[
						'required'=> 'New password is required',
						'min_length' => 'Password must have at least 6 characters'
						
					]
				],
				'newpassword2' => [
					'rules' => 'required|min_length[6]|matches[newpassword]',
					'errors' =>[
						'required'=> 'Confirm your new password',
						'min_length' => 'Password must have at least 6 characters',
						'matches' => 'Confirm password does not match with new password'
					]
				]
					

			]);

			if(!$validation){
				return view('auth/edit_profile',['validation'=> $this ->validator,'adminInfo' => $adminInfo,'admin' =>$admin ]);

			} else {
					$data = [
						'password' => $this->request->getPost('newpassword2')

					];

					$parentModel->update($parent_id,$data);
					return redirect()->to(base_url('auth/edit_profile/'.$parentInfo['parent_id']))->with('status','Password Changed Successfully!');
					

			}
		
	}


}