<?php
include 'main_header.php';
?>

<style>
    table th, table td {
        white-space: nowrap; /* Prevent text from wrapping */
    }

    th, td {
        padding: 8px; /* Adjust padding as needed */
        border: 1px solid black;
    }
    
    th.scope-col {
        width: 100px; /* Set a specific width for the Parent ID column */
    }

    th.title-col {
        min-width: 150px; /* Allow the Title column to expand */
    }

    /* ... Apply similar rules for other columns ... */
</style>

<body>
    <div class="app menu-dark align-content-stretch d-flex flex-wrap">
        <?php include 'sidebar.php'; ?>
        <div class="app-container">
            <div class="app-content">
                <div class="content-wrapper">
                    <div class="container-fluid">
                        <div class="row">
                            <div class="col-sm-12 col-md-12 col-lg-12">
                                <!-- Title and description can go here if needed -->
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-sm-8 col-md-8 col-lg-8">
                                <div class="page-description">
                                    <h1>Top Sheet List</h1>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col">
                                <div class="card">
                                    <div class="card-body">
                                        <div class="table-responsive">
                                            <?php
                                            if (isset($topsheet) && !empty($topsheet)):
                                                $db = db_connect();
                                                $districts = [];
                                                // Group data by district
                                                foreach ($topsheet as $data) {
                                                    $districtQuery = $db->query("SELECT * FROM districts WHERE id='$data->district_id';");
                                                    $district = $districtQuery->getRow();
                                                    if ($district) {
                                                        $districts[$district->district_name][] = $data;
                                                    }
                                                }
                                            ?>
                                            <?php foreach ($districts as $districtName => $districtData): ?>
                                                <h3><?= $districtName ?></h3>
                                                <table>
                                                    <thead>
                                                        <tr>
                                                            <th scope="col">ID</th>
                                                            <th scope="col">Topsheet Name</th>
                                                            <th scope="col">Upozilla</th>
                                                            <th scope="col">Total</th>
                                                            <th scope="col">Created at</th>
                                                            <th scope="col">Action</th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        <?php foreach ($districtData as $data): ?>
                                                            <tr>
                                                                <td><?= $data->id ?></td>
                                                                <td><?= $data->top_sheet_name ?></td>
                                                                <td>
                                                                    <?php 
                                                                        $query = $db->query("SELECT * FROM upozilla WHERE id='$data->upazilla_id';");
                                                                        $upazilla = $query->getRow();
                                                                        echo !empty($upazilla) ? $upazilla->upozilla_name : '';
                                                                    ?>
                                                                </td>
                                                                <td><?= $data->total_details ?></td>
                                                                <td><?= $data->created_at ?></td>
                                                                <td>
                                                                    <div class="btn-group" role="group" aria-label="Basic mixed styles example">
                                                                        <a href="<?= base_url('edit_generated_topsheet/' . $data->id) ?>" class="btn btn-danger btn-sm">Edit</a>
                                                                        <a href="<?= base_url('generate_topsheet_excel/' . $data->id) ?>" class="btn btn-primary btn-sm">Excel Print</a>
                                                                        <a href="<?= base_url('generate_topsheet_pdf/' . $data->id) ?>" class="btn btn-success btn-sm">PDF Print</a>
                                                                    </div>
                                                                </td>
                                                            </tr>
                                                        <?php endforeach; ?>
                                                    </tbody>
                                                </table>
                                            <?php endforeach; ?>
                                            <?php else: ?>
                                                <p>No data available</p>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Javascripts -->
    <script src="<?php echo base_url(); ?>/assets/plugins/jquery/jquery-3.5.1.min.js"></script>
    <script src="<?php echo base_url(); ?>/assets/plugins/bootstrap/js/bootstrap.min.js"></script>
    <script src="<?php echo base_url(); ?>/assets/plugins/perfectscroll/perfect-scrollbar.min.js"></script>
    <script src="<?php echo base_url(); ?>/assets/plugins/pace/pace.min.js"></script>
    <script src="../public/assets/plugins/apexcharts/apexcharts.min.js"></script>
    <script src="<?php echo base_url(); ?>/assets/js/main.min.js"></script>
    <script src="<?php echo base_url(); ?>/assets/js/custom.js"></script>
    <script src="<?php echo base_url(); ?>/assets/js/pages/dashboard.js"></script>

</body>
</html>
